// Copyright 2016 Orus.io. All rights reserved.

package control

import (
	"github.com/m4rw3r/uuid"

	"bitbucket.org/orus-io/go-xbus/api"
)

func (s *Service) handleEnvelopePurge(subject, reply string, req api.ControlEnvelopePurgeReq) {
	s.TaskAdd()

	var rep api.ControlEnvelopePurgeRep
	defer s.SendReply(reply, &rep)

	s.o.EnvelopeStorage.Purge(func(ids []uuid.UUID) []uuid.UUID {
		var result []uuid.UUID
		envProcess := s.o.ProcessStorage.FindProcessForEnvelope(ids)
		for _, id := range ids {
			if _, ok := envProcess[id]; !ok {
				result = append(result, id)
				rep.Count++
			}
		}
		return result
	})
	rep.Status = api.StatusOK
}
