// Copyright 2016 Orus.io. All rights reserved.

package storage

import (
	"time"

	"github.com/m4rw3r/uuid"

	"bitbucket.org/orus-io/go-xbus/api"
)

// A LogStorage stores log entries and can return them
// given some filters
type LogStorage interface {
	Log(api.LogEntry)
	GetProcessMessages(processID uuid.UUID, level api.LogLevel) []api.LogEntry
	PurgeBefore(time.Time) int64
}
