package model

// generated with yago. Better NOT to edit!

import (
	"database/sql"
	"fmt"
	"reflect"

	"github.com/slicebit/qb"

	"github.com/m4rw3r/uuid"
	"github.com/orus-io/yago"
)

const (
	// ActorName is the Name field name
	ActorName = "Name"
	// ActorNameColumnName is the Name field associated column name
	ActorNameColumnName = "name"
	// ActorAccountID is the AccountID field name
	ActorAccountID = "AccountID"
	// ActorAccountIDColumnName is the AccountID field associated column name
	ActorAccountIDColumnName = "account_id"
	// ActorKind is the Kind field name
	ActorKind = "Kind"
	// ActorKindColumnName is the Kind field associated column name
	ActorKindColumnName = "kind"
	// ActorRole is the Role field name
	ActorRole = "Role"
	// ActorRoleColumnName is the Role field associated column name
	ActorRoleColumnName = "role"
	// ActorStatus is the Status field name
	ActorStatus = "Status"
	// ActorStatusColumnName is the Status field associated column name
	ActorStatusColumnName = "status"
	// ActorVisible is the Visible field name
	ActorVisible = "Visible"
	// ActorVisibleColumnName is the Visible field associated column name
	ActorVisibleColumnName = "visible"
	// ActorLastSeen is the LastSeen field name
	ActorLastSeen = "LastSeen"
	// ActorLastSeenColumnName is the LastSeen field associated column name
	ActorLastSeenColumnName = "last_seen"
)

const (
	// ActorTableName is the Actor associated table name
	ActorTableName = "actor"
)

var actorTable = qb.Table(
	ActorTableName,
	qb.Column(ActorNameColumnName, qb.Varchar()).NotNull(),
	qb.Column(ActorAccountIDColumnName, qb.UUID()).Null(),
	qb.Column(ActorKindColumnName, qb.Varchar()).NotNull(),
	qb.Column(ActorRoleColumnName, qb.Varchar()).NotNull(),
	qb.Column(ActorStatusColumnName, qb.Varchar()).NotNull(),
	qb.Column(ActorVisibleColumnName, qb.Boolean()).NotNull(),
	qb.Column(ActorLastSeenColumnName, qb.Timestamp()).NotNull(),
	qb.Column(BaseIDColumnName, qb.UUID()).PrimaryKey().NotNull(),
	qb.Column(BaseCreatedAtColumnName, qb.Timestamp()).NotNull(),
	qb.Column(BaseUpdatedAtColumnName, qb.Timestamp()).Null(),
	qb.UniqueKey(
		ActorNameColumnName,
	),
	qb.ForeignKey(ActorAccountIDColumnName).References(AccountTableName, BaseIDColumnName).OnDelete("SET NULL"),
)

var actorType = reflect.TypeOf(Actor{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (Actor) StructType() reflect.Type {
	return actorType
}

// ActorModel provides direct access to helpers for Actor
// queries
type ActorModel struct {
	mapper    *ActorMapper
	Name      yago.ScalarField
	AccountID yago.ScalarField
	Kind      yago.MarshaledScalarField
	Role      yago.ScalarField
	Status    yago.MarshaledScalarField
	Visible   yago.ScalarField
	LastSeen  yago.ScalarField
	ID        yago.ScalarField
	CreatedAt yago.ScalarField
	UpdatedAt yago.ScalarField
}

// NewActorModel returns a new ActorModel
func NewActorModel(meta *yago.Metadata) ActorModel {
	mapper := NewActorMapper()
	meta.AddMapper(mapper)
	return ActorModel{
		mapper:    mapper,
		Name:      yago.NewScalarField(mapper.Table().C(ActorNameColumnName)),
		AccountID: yago.NewScalarField(mapper.Table().C(ActorAccountIDColumnName)),
		Kind:      yago.NewMarshaledScalarField(mapper.Table().C(ActorKindColumnName)),
		Role:      yago.NewScalarField(mapper.Table().C(ActorRoleColumnName)),
		Status:    yago.NewMarshaledScalarField(mapper.Table().C(ActorStatusColumnName)),
		Visible:   yago.NewScalarField(mapper.Table().C(ActorVisibleColumnName)),
		LastSeen:  yago.NewScalarField(mapper.Table().C(ActorLastSeenColumnName)),
		ID:        yago.NewScalarField(mapper.Table().C(BaseIDColumnName)),
		CreatedAt: yago.NewScalarField(mapper.Table().C(BaseCreatedAtColumnName)),
		UpdatedAt: yago.NewScalarField(mapper.Table().C(BaseUpdatedAtColumnName)),
	}
}

// GetMapper returns the associated ActorMapper instance
func (m ActorModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewActorMapper initialize a NewActorMapper
func NewActorMapper() *ActorMapper {
	m := &ActorMapper{}
	return m
}

// ActorMapper is the Actor mapper
type ActorMapper struct{}

// GetMapper returns itself
func (mapper *ActorMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*ActorMapper) Name() string {
	return "model/Actor"
}

// Table returns the mapper table
func (*ActorMapper) Table() *qb.TableElem {
	return &actorTable
}

// StructType returns the reflect.Type of the mapped structure
func (ActorMapper) StructType() reflect.Type {
	return actorType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper ActorMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*Actor)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Actor{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != (uuid.UUID{}) {
		m[BaseIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, ActorName) {
		m[ActorNameColumnName] = s.Name
	}
	if allValues || yago.StringListContains(fields, ActorAccountID) {
		m[ActorAccountIDColumnName] = s.AccountID
	}
	if allValues || yago.StringListContains(fields, ActorKind) {
		if b, err := s.Kind.MarshalText(); err == nil {
			m[ActorKindColumnName] = b
		} else {
			panic(err)
		}
	}
	if allValues || yago.StringListContains(fields, ActorRole) {
		m[ActorRoleColumnName] = s.Role
	}
	if allValues || yago.StringListContains(fields, ActorStatus) {
		if b, err := s.Status.MarshalText(); err == nil {
			m[ActorStatusColumnName] = b
		} else {
			panic(err)
		}
	}
	if allValues || yago.StringListContains(fields, ActorVisible) {
		m[ActorVisibleColumnName] = s.Visible
	}
	if allValues || yago.StringListContains(fields, ActorLastSeen) {
		m[ActorLastSeenColumnName] = s.LastSeen
	}
	if allValues || yago.StringListContains(fields, BaseCreatedAt) {
		m[BaseCreatedAtColumnName] = s.CreatedAt
	}
	if allValues || yago.StringListContains(fields, BaseUpdatedAt) {
		m[BaseUpdatedAtColumnName] = s.UpdatedAt
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper ActorMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		actorTable.C(ActorNameColumnName),
		actorTable.C(ActorAccountIDColumnName),
		actorTable.C(ActorKindColumnName),
		actorTable.C(ActorRoleColumnName),
		actorTable.C(ActorStatusColumnName),
		actorTable.C(ActorVisibleColumnName),
		actorTable.C(ActorLastSeenColumnName),
		actorTable.C(BaseIDColumnName),
		actorTable.C(BaseCreatedAtColumnName),
		actorTable.C(BaseUpdatedAtColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper ActorMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Actor)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Actor{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper ActorMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Actor)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Actor{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	var KindText []byte
	var StatusText []byte
	if err := rows.Scan(
		&s.Name,
		&s.AccountID,
		&KindText,
		&s.Role,
		&StatusText,
		&s.Visible,
		&s.LastSeen,
		&s.ID,
		&s.CreatedAt,
		&s.UpdatedAt,
	); err != nil {
		return err
	}
	if err := s.Kind.UnmarshalText(KindText); err != nil {
		return err
	}
	if err := s.Status.UnmarshalText(StatusText); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (ActorMapper) AutoIncrementPKey() bool {
	return false
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (ActorMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	panic("Actor has no auto increment column in its pkey")
}

// PKey returns the instance primary key values
func (mapper ActorMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*Actor)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper ActorMapper) PKeyClause(values []interface{}) qb.Clause {
	return actorTable.C(BaseIDColumnName).Eq(values[0])
}
