package model

// generated with yago. Better NOT to edit!

import (
	"database/sql"
	"fmt"
	"reflect"

	"github.com/slicebit/qb"

	"github.com/m4rw3r/uuid"
	"github.com/orus-io/yago"
)

const (
	// ProcessTriggerEmitterID is the TriggerEmitterID field name
	ProcessTriggerEmitterID = "TriggerEmitterID"
	// ProcessTriggerEmitterIDColumnName is the TriggerEmitterID field associated column name
	ProcessTriggerEmitterIDColumnName = "trigger_emitter_id"
	// ProcessTriggerEnvelopeID is the TriggerEnvelopeID field name
	ProcessTriggerEnvelopeID = "TriggerEnvelopeID"
	// ProcessTriggerEnvelopeIDColumnName is the TriggerEnvelopeID field associated column name
	ProcessTriggerEnvelopeIDColumnName = "trigger_envelope_id"
	// ProcessGraphID is the GraphID field name
	ProcessGraphID = "GraphID"
	// ProcessGraphIDColumnName is the GraphID field associated column name
	ProcessGraphIDColumnName = "graph_id"
	// ProcessSourceNodeID is the SourceNodeID field name
	ProcessSourceNodeID = "SourceNodeID"
	// ProcessSourceNodeIDColumnName is the SourceNodeID field associated column name
	ProcessSourceNodeIDColumnName = "source_node_id"
	// ProcessSourceSlotID is the SourceSlotID field name
	ProcessSourceSlotID = "SourceSlotID"
	// ProcessSourceSlotIDColumnName is the SourceSlotID field associated column name
	ProcessSourceSlotIDColumnName = "source_slot_id"
)

const (
	// ProcessTableName is the Process associated table name
	ProcessTableName = "process"
)

var processTable = qb.Table(
	ProcessTableName,
	qb.Column(ProcessTriggerEmitterIDColumnName, qb.UUID()).NotNull(),
	qb.Column(ProcessTriggerEnvelopeIDColumnName, qb.UUID()).NotNull(),
	qb.Column(ProcessGraphIDColumnName, qb.UUID()).NotNull(),
	qb.Column(ProcessSourceNodeIDColumnName, qb.Varchar()).NotNull(),
	qb.Column(ProcessSourceSlotIDColumnName, qb.Varchar()).NotNull(),
	qb.Column(BaseIDColumnName, qb.UUID()).PrimaryKey().NotNull(),
	qb.Column(BaseCreatedAtColumnName, qb.Timestamp()).NotNull(),
	qb.Column(BaseUpdatedAtColumnName, qb.Timestamp()).Null(),
	qb.ForeignKey(ProcessTriggerEmitterIDColumnName).References(ActorTableName, BaseIDColumnName),
	qb.ForeignKey(ProcessTriggerEnvelopeIDColumnName).References(EnvelopeTableName, BaseIDColumnName),
)

var processType = reflect.TypeOf(Process{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (Process) StructType() reflect.Type {
	return processType
}

// ProcessModel provides direct access to helpers for Process
// queries
type ProcessModel struct {
	mapper            *ProcessMapper
	TriggerEmitterID  yago.ScalarField
	TriggerEnvelopeID yago.ScalarField
	GraphID           yago.ScalarField
	SourceNodeID      yago.ScalarField
	SourceSlotID      yago.ScalarField
	ID                yago.ScalarField
	CreatedAt         yago.ScalarField
	UpdatedAt         yago.ScalarField
}

// NewProcessModel returns a new ProcessModel
func NewProcessModel(meta *yago.Metadata) ProcessModel {
	mapper := NewProcessMapper()
	meta.AddMapper(mapper)
	return ProcessModel{
		mapper:            mapper,
		TriggerEmitterID:  yago.NewScalarField(mapper.Table().C(ProcessTriggerEmitterIDColumnName)),
		TriggerEnvelopeID: yago.NewScalarField(mapper.Table().C(ProcessTriggerEnvelopeIDColumnName)),
		GraphID:           yago.NewScalarField(mapper.Table().C(ProcessGraphIDColumnName)),
		SourceNodeID:      yago.NewScalarField(mapper.Table().C(ProcessSourceNodeIDColumnName)),
		SourceSlotID:      yago.NewScalarField(mapper.Table().C(ProcessSourceSlotIDColumnName)),
		ID:                yago.NewScalarField(mapper.Table().C(BaseIDColumnName)),
		CreatedAt:         yago.NewScalarField(mapper.Table().C(BaseCreatedAtColumnName)),
		UpdatedAt:         yago.NewScalarField(mapper.Table().C(BaseUpdatedAtColumnName)),
	}
}

// GetMapper returns the associated ProcessMapper instance
func (m ProcessModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewProcessMapper initialize a NewProcessMapper
func NewProcessMapper() *ProcessMapper {
	m := &ProcessMapper{}
	return m
}

// ProcessMapper is the Process mapper
type ProcessMapper struct{}

// GetMapper returns itself
func (mapper *ProcessMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*ProcessMapper) Name() string {
	return "model/Process"
}

// Table returns the mapper table
func (*ProcessMapper) Table() *qb.TableElem {
	return &processTable
}

// StructType returns the reflect.Type of the mapped structure
func (ProcessMapper) StructType() reflect.Type {
	return processType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper ProcessMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*Process)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Process{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != (uuid.UUID{}) {
		m[BaseIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, ProcessTriggerEmitterID) {
		m[ProcessTriggerEmitterIDColumnName] = s.TriggerEmitterID
	}
	if allValues || yago.StringListContains(fields, ProcessTriggerEnvelopeID) {
		m[ProcessTriggerEnvelopeIDColumnName] = s.TriggerEnvelopeID
	}
	if allValues || yago.StringListContains(fields, ProcessGraphID) {
		m[ProcessGraphIDColumnName] = s.GraphID
	}
	if allValues || yago.StringListContains(fields, ProcessSourceNodeID) {
		m[ProcessSourceNodeIDColumnName] = s.SourceNodeID
	}
	if allValues || yago.StringListContains(fields, ProcessSourceSlotID) {
		m[ProcessSourceSlotIDColumnName] = s.SourceSlotID
	}
	if allValues || yago.StringListContains(fields, BaseCreatedAt) {
		m[BaseCreatedAtColumnName] = s.CreatedAt
	}
	if allValues || yago.StringListContains(fields, BaseUpdatedAt) {
		m[BaseUpdatedAtColumnName] = s.UpdatedAt
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper ProcessMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		processTable.C(ProcessTriggerEmitterIDColumnName),
		processTable.C(ProcessTriggerEnvelopeIDColumnName),
		processTable.C(ProcessGraphIDColumnName),
		processTable.C(ProcessSourceNodeIDColumnName),
		processTable.C(ProcessSourceSlotIDColumnName),
		processTable.C(BaseIDColumnName),
		processTable.C(BaseCreatedAtColumnName),
		processTable.C(BaseUpdatedAtColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper ProcessMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Process)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Process{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper ProcessMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Process)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Process{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	if err := rows.Scan(
		&s.TriggerEmitterID,
		&s.TriggerEnvelopeID,
		&s.GraphID,
		&s.SourceNodeID,
		&s.SourceSlotID,
		&s.ID,
		&s.CreatedAt,
		&s.UpdatedAt,
	); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (ProcessMapper) AutoIncrementPKey() bool {
	return false
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (ProcessMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	panic("Process has no auto increment column in its pkey")
}

// PKey returns the instance primary key values
func (mapper ProcessMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*Process)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper ProcessMapper) PKeyClause(values []interface{}) qb.Clause {
	return processTable.C(BaseIDColumnName).Eq(values[0])
}

const (
	// RouteID is the ID field name
	RouteID = "ID"
	// RouteIDColumnName is the ID field associated column name
	RouteIDColumnName = "id"
	// RouteProcessID is the ProcessID field name
	RouteProcessID = "ProcessID"
	// RouteProcessIDColumnName is the ProcessID field associated column name
	RouteProcessIDColumnName = "process_id"
	// RouteSource is the Source field name
	RouteSource = "Source"
	// RouteSourceColumnName is the Source field associated column name
	RouteSourceColumnName = "source"
	// RouteEnvelopeID is the EnvelopeID field name
	RouteEnvelopeID = "EnvelopeID"
	// RouteEnvelopeIDColumnName is the EnvelopeID field associated column name
	RouteEnvelopeIDColumnName = "envelope_id"
)

const (
	// RouteTableName is the Route associated table name
	RouteTableName = "route"
)

var routeTable = qb.Table(
	RouteTableName,
	qb.Column(RouteIDColumnName, qb.BigInt()).PrimaryKey().AutoIncrement().NotNull(),
	qb.Column(RouteProcessIDColumnName, qb.UUID()).NotNull(),
	qb.Column(RouteSourceColumnName, qb.Text()).NotNull(),
	qb.Column(RouteEnvelopeIDColumnName, qb.UUID()).NotNull(),
	qb.UniqueKey(
		RouteProcessIDColumnName,
		RouteSourceColumnName,
		RouteEnvelopeIDColumnName,
	),
	qb.ForeignKey(RouteProcessIDColumnName).References(ProcessTableName, BaseIDColumnName).OnDelete("CASCADE"),
)

var routeType = reflect.TypeOf(Route{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (Route) StructType() reflect.Type {
	return routeType
}

// RouteModel provides direct access to helpers for Route
// queries
type RouteModel struct {
	mapper     *RouteMapper
	ID         yago.ScalarField
	ProcessID  yago.ScalarField
	Source     yago.ScalarField
	EnvelopeID yago.ScalarField
}

// NewRouteModel returns a new RouteModel
func NewRouteModel(meta *yago.Metadata) RouteModel {
	mapper := NewRouteMapper()
	meta.AddMapper(mapper)
	return RouteModel{
		mapper:     mapper,
		ID:         yago.NewScalarField(mapper.Table().C(RouteIDColumnName)),
		ProcessID:  yago.NewScalarField(mapper.Table().C(RouteProcessIDColumnName)),
		Source:     yago.NewScalarField(mapper.Table().C(RouteSourceColumnName)),
		EnvelopeID: yago.NewScalarField(mapper.Table().C(RouteEnvelopeIDColumnName)),
	}
}

// GetMapper returns the associated RouteMapper instance
func (m RouteModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewRouteMapper initialize a NewRouteMapper
func NewRouteMapper() *RouteMapper {
	m := &RouteMapper{}
	return m
}

// RouteMapper is the Route mapper
type RouteMapper struct{}

// GetMapper returns itself
func (mapper *RouteMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*RouteMapper) Name() string {
	return "model/Route"
}

// Table returns the mapper table
func (*RouteMapper) Table() *qb.TableElem {
	return &routeTable
}

// StructType returns the reflect.Type of the mapped structure
func (RouteMapper) StructType() reflect.Type {
	return routeType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper RouteMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*Route)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Route{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != 0 {
		m[RouteIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, RouteProcessID) {
		m[RouteProcessIDColumnName] = s.ProcessID
	}
	if allValues || yago.StringListContains(fields, RouteSource) {
		m[RouteSourceColumnName] = s.Source
	}
	if allValues || yago.StringListContains(fields, RouteEnvelopeID) {
		m[RouteEnvelopeIDColumnName] = s.EnvelopeID
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper RouteMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		routeTable.C(RouteIDColumnName),
		routeTable.C(RouteProcessIDColumnName),
		routeTable.C(RouteSourceColumnName),
		routeTable.C(RouteEnvelopeIDColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper RouteMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Route)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Route{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper RouteMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Route)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Route{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	if err := rows.Scan(
		&s.ID,
		&s.ProcessID,
		&s.Source,
		&s.EnvelopeID,
	); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (RouteMapper) AutoIncrementPKey() bool {
	return true
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (RouteMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	s := instance.(*Route)
	s.ID = value
}

// PKey returns the instance primary key values
func (mapper RouteMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*Route)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper RouteMapper) PKeyClause(values []interface{}) qb.Clause {
	return routeTable.C(RouteIDColumnName).Eq(values[0])
}

const (
	// RouteTargetID is the ID field name
	RouteTargetID = "ID"
	// RouteTargetIDColumnName is the ID field associated column name
	RouteTargetIDColumnName = "id"
	// RouteTargetRouteID is the RouteID field name
	RouteTargetRouteID = "RouteID"
	// RouteTargetRouteIDColumnName is the RouteID field associated column name
	RouteTargetRouteIDColumnName = "route_id"
	// RouteTargetActorID is the ActorID field name
	RouteTargetActorID = "ActorID"
	// RouteTargetActorIDColumnName is the ActorID field associated column name
	RouteTargetActorIDColumnName = "actor_id"
	// RouteTargetNodeID is the NodeID field name
	RouteTargetNodeID = "NodeID"
	// RouteTargetNodeIDColumnName is the NodeID field associated column name
	RouteTargetNodeIDColumnName = "node_id"
	// RouteTargetInput is the Input field name
	RouteTargetInput = "Input"
	// RouteTargetInputColumnName is the Input field associated column name
	RouteTargetInputColumnName = "input"
)

const (
	// RouteTargetTableName is the RouteTarget associated table name
	RouteTargetTableName = "route_target"
)

var routeTargetTable = qb.Table(
	RouteTargetTableName,
	qb.Column(RouteTargetIDColumnName, qb.BigInt()).PrimaryKey().AutoIncrement().NotNull(),
	qb.Column(RouteTargetRouteIDColumnName, qb.BigInt()).NotNull(),
	qb.Column(RouteTargetActorIDColumnName, qb.UUID()).NotNull(),
	qb.Column(RouteTargetNodeIDColumnName, qb.Varchar()).NotNull(),
	qb.Column(RouteTargetInputColumnName, qb.Varchar()).NotNull(),
	qb.UniqueKey(
		RouteTargetRouteIDColumnName,
		RouteTargetActorIDColumnName,
		RouteTargetNodeIDColumnName,
		RouteTargetInputColumnName,
	),
	qb.ForeignKey(RouteTargetRouteIDColumnName).References(RouteTableName, RouteIDColumnName).OnDelete("CASCADE"),
	qb.ForeignKey(RouteTargetActorIDColumnName).References(ActorTableName, BaseIDColumnName),
)

var routeTargetType = reflect.TypeOf(RouteTarget{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (RouteTarget) StructType() reflect.Type {
	return routeTargetType
}

// RouteTargetModel provides direct access to helpers for RouteTarget
// queries
type RouteTargetModel struct {
	mapper  *RouteTargetMapper
	ID      yago.ScalarField
	RouteID yago.ScalarField
	ActorID yago.ScalarField
	NodeID  yago.ScalarField
	Input   yago.ScalarField
}

// NewRouteTargetModel returns a new RouteTargetModel
func NewRouteTargetModel(meta *yago.Metadata) RouteTargetModel {
	mapper := NewRouteTargetMapper()
	meta.AddMapper(mapper)
	return RouteTargetModel{
		mapper:  mapper,
		ID:      yago.NewScalarField(mapper.Table().C(RouteTargetIDColumnName)),
		RouteID: yago.NewScalarField(mapper.Table().C(RouteTargetRouteIDColumnName)),
		ActorID: yago.NewScalarField(mapper.Table().C(RouteTargetActorIDColumnName)),
		NodeID:  yago.NewScalarField(mapper.Table().C(RouteTargetNodeIDColumnName)),
		Input:   yago.NewScalarField(mapper.Table().C(RouteTargetInputColumnName)),
	}
}

// GetMapper returns the associated RouteTargetMapper instance
func (m RouteTargetModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewRouteTargetMapper initialize a NewRouteTargetMapper
func NewRouteTargetMapper() *RouteTargetMapper {
	m := &RouteTargetMapper{}
	return m
}

// RouteTargetMapper is the RouteTarget mapper
type RouteTargetMapper struct{}

// GetMapper returns itself
func (mapper *RouteTargetMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*RouteTargetMapper) Name() string {
	return "model/RouteTarget"
}

// Table returns the mapper table
func (*RouteTargetMapper) Table() *qb.TableElem {
	return &routeTargetTable
}

// StructType returns the reflect.Type of the mapped structure
func (RouteTargetMapper) StructType() reflect.Type {
	return routeTargetType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper RouteTargetMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*RouteTarget)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &RouteTarget{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != 0 {
		m[RouteTargetIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, RouteTargetRouteID) {
		m[RouteTargetRouteIDColumnName] = s.RouteID
	}
	if allValues || yago.StringListContains(fields, RouteTargetActorID) {
		m[RouteTargetActorIDColumnName] = s.ActorID
	}
	if allValues || yago.StringListContains(fields, RouteTargetNodeID) {
		m[RouteTargetNodeIDColumnName] = s.NodeID
	}
	if allValues || yago.StringListContains(fields, RouteTargetInput) {
		m[RouteTargetInputColumnName] = s.Input
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper RouteTargetMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		routeTargetTable.C(RouteTargetIDColumnName),
		routeTargetTable.C(RouteTargetRouteIDColumnName),
		routeTargetTable.C(RouteTargetActorIDColumnName),
		routeTargetTable.C(RouteTargetNodeIDColumnName),
		routeTargetTable.C(RouteTargetInputColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper RouteTargetMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*RouteTarget)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &RouteTarget{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper RouteTargetMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*RouteTarget)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &RouteTarget{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	if err := rows.Scan(
		&s.ID,
		&s.RouteID,
		&s.ActorID,
		&s.NodeID,
		&s.Input,
	); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (RouteTargetMapper) AutoIncrementPKey() bool {
	return true
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (RouteTargetMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	s := instance.(*RouteTarget)
	s.ID = value
}

// PKey returns the instance primary key values
func (mapper RouteTargetMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*RouteTarget)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper RouteTargetMapper) PKeyClause(values []interface{}) qb.Clause {
	return routeTargetTable.C(RouteTargetIDColumnName).Eq(values[0])
}

const (
	// EmissionID is the ID field name
	EmissionID = "ID"
	// EmissionIDColumnName is the ID field associated column name
	EmissionIDColumnName = "id"
	// EmissionProcessID is the ProcessID field name
	EmissionProcessID = "ProcessID"
	// EmissionProcessIDColumnName is the ProcessID field associated column name
	EmissionProcessIDColumnName = "process_id"
	// EmissionEnvelopeID is the EnvelopeID field name
	EmissionEnvelopeID = "EnvelopeID"
	// EmissionEnvelopeIDColumnName is the EnvelopeID field associated column name
	EmissionEnvelopeIDColumnName = "envelope_id"
	// EmissionTargetActor is the TargetActor field name
	EmissionTargetActor = "TargetActor"
	// EmissionTargetActorColumnName is the TargetActor field associated column name
	EmissionTargetActorColumnName = "target_actor"
	// EmissionTargetNodeID is the TargetNodeID field name
	EmissionTargetNodeID = "TargetNodeID"
	// EmissionTargetNodeIDColumnName is the TargetNodeID field associated column name
	EmissionTargetNodeIDColumnName = "target_node_id"
	// EmissionTargetInput is the TargetInput field name
	EmissionTargetInput = "TargetInput"
	// EmissionTargetInputColumnName is the TargetInput field associated column name
	EmissionTargetInputColumnName = "target_input"
	// EmissionStart is the Start field name
	EmissionStart = "Start"
	// EmissionStartColumnName is the Start field associated column name
	EmissionStartColumnName = "start"
	// EmissionComplete is the Complete field name
	EmissionComplete = "Complete"
	// EmissionCompleteColumnName is the Complete field associated column name
	EmissionCompleteColumnName = "complete"
	// EmissionEventPositions is the EventPositions field name
	EmissionEventPositions = "EventPositions"
	// EmissionEventPositionsColumnName is the EventPositions field associated column name
	EmissionEventPositionsColumnName = "event_positions"
)

const (
	// EmissionTableName is the Emission associated table name
	EmissionTableName = "emission"
)

var emissionTable = qb.Table(
	EmissionTableName,
	qb.Column(EmissionIDColumnName, qb.BigInt()).PrimaryKey().AutoIncrement().NotNull(),
	qb.Column(EmissionProcessIDColumnName, qb.UUID()).NotNull(),
	qb.Column(EmissionEnvelopeIDColumnName, qb.UUID()).NotNull(),
	qb.Column(EmissionTargetActorColumnName, qb.UUID()).NotNull(),
	qb.Column(EmissionTargetNodeIDColumnName, qb.Varchar()).NotNull(),
	qb.Column(EmissionTargetInputColumnName, qb.Varchar()).NotNull(),
	qb.Column(EmissionStartColumnName, qb.Boolean()).NotNull(),
	qb.Column(EmissionCompleteColumnName, qb.Boolean()).NotNull(),
	qb.Column(EmissionEventPositionsColumnName, qb.Text()).NotNull(),
	qb.UniqueKey(
		EmissionProcessIDColumnName,
		EmissionEnvelopeIDColumnName,
		EmissionTargetActorColumnName,
		EmissionTargetNodeIDColumnName,
		EmissionTargetInputColumnName,
	),
	qb.ForeignKey(EmissionProcessIDColumnName).References(ProcessTableName, BaseIDColumnName).OnDelete("CASCADE"),
	qb.ForeignKey(EmissionEnvelopeIDColumnName).References(EnvelopeTableName, BaseIDColumnName),
	qb.ForeignKey(EmissionTargetActorColumnName).References(ActorTableName, BaseIDColumnName),
)

var emissionType = reflect.TypeOf(Emission{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (Emission) StructType() reflect.Type {
	return emissionType
}

// EmissionModel provides direct access to helpers for Emission
// queries
type EmissionModel struct {
	mapper         *EmissionMapper
	ID             yago.ScalarField
	ProcessID      yago.ScalarField
	EnvelopeID     yago.ScalarField
	TargetActor    yago.ScalarField
	TargetNodeID   yago.ScalarField
	TargetInput    yago.ScalarField
	Start          yago.ScalarField
	Complete       yago.ScalarField
	EventPositions yago.ScalarField
}

// NewEmissionModel returns a new EmissionModel
func NewEmissionModel(meta *yago.Metadata) EmissionModel {
	mapper := NewEmissionMapper()
	meta.AddMapper(mapper)
	return EmissionModel{
		mapper:         mapper,
		ID:             yago.NewScalarField(mapper.Table().C(EmissionIDColumnName)),
		ProcessID:      yago.NewScalarField(mapper.Table().C(EmissionProcessIDColumnName)),
		EnvelopeID:     yago.NewScalarField(mapper.Table().C(EmissionEnvelopeIDColumnName)),
		TargetActor:    yago.NewScalarField(mapper.Table().C(EmissionTargetActorColumnName)),
		TargetNodeID:   yago.NewScalarField(mapper.Table().C(EmissionTargetNodeIDColumnName)),
		TargetInput:    yago.NewScalarField(mapper.Table().C(EmissionTargetInputColumnName)),
		Start:          yago.NewScalarField(mapper.Table().C(EmissionStartColumnName)),
		Complete:       yago.NewScalarField(mapper.Table().C(EmissionCompleteColumnName)),
		EventPositions: yago.NewScalarField(mapper.Table().C(EmissionEventPositionsColumnName)),
	}
}

// GetMapper returns the associated EmissionMapper instance
func (m EmissionModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewEmissionMapper initialize a NewEmissionMapper
func NewEmissionMapper() *EmissionMapper {
	m := &EmissionMapper{}
	return m
}

// EmissionMapper is the Emission mapper
type EmissionMapper struct{}

// GetMapper returns itself
func (mapper *EmissionMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*EmissionMapper) Name() string {
	return "model/Emission"
}

// Table returns the mapper table
func (*EmissionMapper) Table() *qb.TableElem {
	return &emissionTable
}

// StructType returns the reflect.Type of the mapped structure
func (EmissionMapper) StructType() reflect.Type {
	return emissionType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper EmissionMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*Emission)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Emission{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != 0 {
		m[EmissionIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, EmissionProcessID) {
		m[EmissionProcessIDColumnName] = s.ProcessID
	}
	if allValues || yago.StringListContains(fields, EmissionEnvelopeID) {
		m[EmissionEnvelopeIDColumnName] = s.EnvelopeID
	}
	if allValues || yago.StringListContains(fields, EmissionTargetActor) {
		m[EmissionTargetActorColumnName] = s.TargetActor
	}
	if allValues || yago.StringListContains(fields, EmissionTargetNodeID) {
		m[EmissionTargetNodeIDColumnName] = s.TargetNodeID
	}
	if allValues || yago.StringListContains(fields, EmissionTargetInput) {
		m[EmissionTargetInputColumnName] = s.TargetInput
	}
	if allValues || yago.StringListContains(fields, EmissionStart) {
		m[EmissionStartColumnName] = s.Start
	}
	if allValues || yago.StringListContains(fields, EmissionComplete) {
		m[EmissionCompleteColumnName] = s.Complete
	}
	if allValues || yago.StringListContains(fields, EmissionEventPositions) {
		m[EmissionEventPositionsColumnName] = s.EventPositions
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper EmissionMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		emissionTable.C(EmissionIDColumnName),
		emissionTable.C(EmissionProcessIDColumnName),
		emissionTable.C(EmissionEnvelopeIDColumnName),
		emissionTable.C(EmissionTargetActorColumnName),
		emissionTable.C(EmissionTargetNodeIDColumnName),
		emissionTable.C(EmissionTargetInputColumnName),
		emissionTable.C(EmissionStartColumnName),
		emissionTable.C(EmissionCompleteColumnName),
		emissionTable.C(EmissionEventPositionsColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper EmissionMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Emission)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Emission{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper EmissionMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Emission)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Emission{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	if err := rows.Scan(
		&s.ID,
		&s.ProcessID,
		&s.EnvelopeID,
		&s.TargetActor,
		&s.TargetNodeID,
		&s.TargetInput,
		&s.Start,
		&s.Complete,
		&s.EventPositions,
	); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (EmissionMapper) AutoIncrementPKey() bool {
	return true
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (EmissionMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	s := instance.(*Emission)
	s.ID = value
}

// PKey returns the instance primary key values
func (mapper EmissionMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*Emission)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper EmissionMapper) PKeyClause(values []interface{}) qb.Clause {
	return emissionTable.C(EmissionIDColumnName).Eq(values[0])
}

const (
	// ProcessLogEntryID is the ID field name
	ProcessLogEntryID = "ID"
	// ProcessLogEntryIDColumnName is the ID field associated column name
	ProcessLogEntryIDColumnName = "id"
	// ProcessLogEntryTimestamp is the Timestamp field name
	ProcessLogEntryTimestamp = "Timestamp"
	// ProcessLogEntryTimestampColumnName is the Timestamp field associated column name
	ProcessLogEntryTimestampColumnName = "timestamp"
	// ProcessLogEntryProcessID is the ProcessID field name
	ProcessLogEntryProcessID = "ProcessID"
	// ProcessLogEntryProcessIDColumnName is the ProcessID field associated column name
	ProcessLogEntryProcessIDColumnName = "process_id"
	// ProcessLogEntryData is the Data field name
	ProcessLogEntryData = "Data"
	// ProcessLogEntryDataColumnName is the Data field associated column name
	ProcessLogEntryDataColumnName = "data"
	// ProcessLogEntryLogProcessed is the LogProcessed field name
	ProcessLogEntryLogProcessed = "LogProcessed"
	// ProcessLogEntryLogProcessedColumnName is the LogProcessed field associated column name
	ProcessLogEntryLogProcessedColumnName = "log_processed"
	// ProcessLogEntryProcessingError is the ProcessingError field name
	ProcessLogEntryProcessingError = "ProcessingError"
	// ProcessLogEntryProcessingErrorColumnName is the ProcessingError field associated column name
	ProcessLogEntryProcessingErrorColumnName = "processing_error"
)

const (
	// ProcessLogEntryTableName is the ProcessLogEntry associated table name
	ProcessLogEntryTableName = "process_log_entry"
)

var processLogEntryTable = qb.Table(
	ProcessLogEntryTableName,
	qb.Column(ProcessLogEntryIDColumnName, qb.BigInt()).PrimaryKey().AutoIncrement().NotNull(),
	qb.Column(ProcessLogEntryTimestampColumnName, qb.Timestamp()).NotNull(),
	qb.Column(ProcessLogEntryProcessIDColumnName, qb.UUID()).NotNull(),
	qb.Column(ProcessLogEntryDataColumnName, qb.Text()).NotNull(),
	qb.Column(ProcessLogEntryLogProcessedColumnName, qb.Boolean()).NotNull(),
	qb.Column(ProcessLogEntryProcessingErrorColumnName, qb.Boolean()).NotNull(),
	qb.ForeignKey(ProcessLogEntryProcessIDColumnName).References(ProcessTableName, BaseIDColumnName).OnDelete("CASCADE"),
)

var processLogEntryType = reflect.TypeOf(ProcessLogEntry{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (ProcessLogEntry) StructType() reflect.Type {
	return processLogEntryType
}

// ProcessLogEntryModel provides direct access to helpers for ProcessLogEntry
// queries
type ProcessLogEntryModel struct {
	mapper          *ProcessLogEntryMapper
	ID              yago.ScalarField
	Timestamp       yago.ScalarField
	ProcessID       yago.ScalarField
	Data            yago.ScalarField
	LogProcessed    yago.ScalarField
	ProcessingError yago.ScalarField
}

// NewProcessLogEntryModel returns a new ProcessLogEntryModel
func NewProcessLogEntryModel(meta *yago.Metadata) ProcessLogEntryModel {
	mapper := NewProcessLogEntryMapper()
	meta.AddMapper(mapper)
	return ProcessLogEntryModel{
		mapper:          mapper,
		ID:              yago.NewScalarField(mapper.Table().C(ProcessLogEntryIDColumnName)),
		Timestamp:       yago.NewScalarField(mapper.Table().C(ProcessLogEntryTimestampColumnName)),
		ProcessID:       yago.NewScalarField(mapper.Table().C(ProcessLogEntryProcessIDColumnName)),
		Data:            yago.NewScalarField(mapper.Table().C(ProcessLogEntryDataColumnName)),
		LogProcessed:    yago.NewScalarField(mapper.Table().C(ProcessLogEntryLogProcessedColumnName)),
		ProcessingError: yago.NewScalarField(mapper.Table().C(ProcessLogEntryProcessingErrorColumnName)),
	}
}

// GetMapper returns the associated ProcessLogEntryMapper instance
func (m ProcessLogEntryModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewProcessLogEntryMapper initialize a NewProcessLogEntryMapper
func NewProcessLogEntryMapper() *ProcessLogEntryMapper {
	m := &ProcessLogEntryMapper{}
	return m
}

// ProcessLogEntryMapper is the ProcessLogEntry mapper
type ProcessLogEntryMapper struct{}

// GetMapper returns itself
func (mapper *ProcessLogEntryMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*ProcessLogEntryMapper) Name() string {
	return "model/ProcessLogEntry"
}

// Table returns the mapper table
func (*ProcessLogEntryMapper) Table() *qb.TableElem {
	return &processLogEntryTable
}

// StructType returns the reflect.Type of the mapped structure
func (ProcessLogEntryMapper) StructType() reflect.Type {
	return processLogEntryType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper ProcessLogEntryMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*ProcessLogEntry)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &ProcessLogEntry{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != 0 {
		m[ProcessLogEntryIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, ProcessLogEntryTimestamp) {
		m[ProcessLogEntryTimestampColumnName] = s.Timestamp
	}
	if allValues || yago.StringListContains(fields, ProcessLogEntryProcessID) {
		m[ProcessLogEntryProcessIDColumnName] = s.ProcessID
	}
	if allValues || yago.StringListContains(fields, ProcessLogEntryData) {
		m[ProcessLogEntryDataColumnName] = s.Data
	}
	if allValues || yago.StringListContains(fields, ProcessLogEntryLogProcessed) {
		m[ProcessLogEntryLogProcessedColumnName] = s.LogProcessed
	}
	if allValues || yago.StringListContains(fields, ProcessLogEntryProcessingError) {
		m[ProcessLogEntryProcessingErrorColumnName] = s.ProcessingError
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper ProcessLogEntryMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		processLogEntryTable.C(ProcessLogEntryIDColumnName),
		processLogEntryTable.C(ProcessLogEntryTimestampColumnName),
		processLogEntryTable.C(ProcessLogEntryProcessIDColumnName),
		processLogEntryTable.C(ProcessLogEntryDataColumnName),
		processLogEntryTable.C(ProcessLogEntryLogProcessedColumnName),
		processLogEntryTable.C(ProcessLogEntryProcessingErrorColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper ProcessLogEntryMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*ProcessLogEntry)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &ProcessLogEntry{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper ProcessLogEntryMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*ProcessLogEntry)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &ProcessLogEntry{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	if err := rows.Scan(
		&s.ID,
		&s.Timestamp,
		&s.ProcessID,
		&s.Data,
		&s.LogProcessed,
		&s.ProcessingError,
	); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (ProcessLogEntryMapper) AutoIncrementPKey() bool {
	return true
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (ProcessLogEntryMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	s := instance.(*ProcessLogEntry)
	s.ID = value
}

// PKey returns the instance primary key values
func (mapper ProcessLogEntryMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*ProcessLogEntry)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper ProcessLogEntryMapper) PKeyClause(values []interface{}) qb.Clause {
	return processLogEntryTable.C(ProcessLogEntryIDColumnName).Eq(values[0])
}

const (
	// ProcessStateProcessID is the ProcessID field name
	ProcessStateProcessID = "ProcessID"
	// ProcessStateProcessIDColumnName is the ProcessID field associated column name
	ProcessStateProcessIDColumnName = "process_id"
	// ProcessStateStatus is the Status field name
	ProcessStateStatus = "Status"
	// ProcessStateStatusColumnName is the Status field associated column name
	ProcessStateStatusColumnName = "status"
	// ProcessStateStatusChanged is the StatusChanged field name
	ProcessStateStatusChanged = "StatusChanged"
	// ProcessStateStatusChangedColumnName is the StatusChanged field associated column name
	ProcessStateStatusChangedColumnName = "status_changed"
	// ProcessStateStatusReason is the StatusReason field name
	ProcessStateStatusReason = "StatusReason"
	// ProcessStateStatusReasonColumnName is the StatusReason field associated column name
	ProcessStateStatusReasonColumnName = "status_reason"
	// ProcessStateNodeStates is the NodeStates field name
	ProcessStateNodeStates = "NodeStates"
	// ProcessStateNodeStatesColumnName is the NodeStates field associated column name
	ProcessStateNodeStatesColumnName = "node_states"
	// ProcessStateNodeStatesChanged is the NodeStatesChanged field name
	ProcessStateNodeStatesChanged = "NodeStatesChanged"
	// ProcessStateNodeStatesChangedColumnName is the NodeStatesChanged field associated column name
	ProcessStateNodeStatesChangedColumnName = "node_states_changed"
	// ProcessStatePMLevel is the PMLevel field name
	ProcessStatePMLevel = "PMLevel"
	// ProcessStatePMLevelColumnName is the PMLevel field associated column name
	ProcessStatePMLevelColumnName = "pm_level"
	// ProcessStatePMStatus is the PMStatus field name
	ProcessStatePMStatus = "PMStatus"
	// ProcessStatePMStatusColumnName is the PMStatus field associated column name
	ProcessStatePMStatusColumnName = "pm_status"
	// ProcessStatePMComment is the PMComment field name
	ProcessStatePMComment = "PMComment"
	// ProcessStatePMCommentColumnName is the PMComment field associated column name
	ProcessStatePMCommentColumnName = "pm_comment"
	// ProcessStatePMChanged is the PMChanged field name
	ProcessStatePMChanged = "PMChanged"
	// ProcessStatePMChangedColumnName is the PMChanged field associated column name
	ProcessStatePMChangedColumnName = "pm_changed"
)

const (
	// ProcessStateTableName is the ProcessState associated table name
	ProcessStateTableName = "process_state"
)

var processStateTable = qb.Table(
	ProcessStateTableName,
	qb.Column(ProcessStateProcessIDColumnName, qb.UUID()).PrimaryKey().NotNull(),
	qb.Column(ProcessStateStatusColumnName, qb.Varchar()).NotNull(),
	qb.Column(ProcessStateStatusChangedColumnName, qb.Timestamp()).NotNull(),
	qb.Column(ProcessStateStatusReasonColumnName, qb.Text()).NotNull(),
	qb.Column(ProcessStateNodeStatesColumnName, qb.Text()).NotNull(),
	qb.Column(ProcessStateNodeStatesChangedColumnName, qb.Timestamp()).NotNull(),
	qb.Column(ProcessStatePMLevelColumnName, qb.Varchar()).NotNull(),
	qb.Column(ProcessStatePMStatusColumnName, qb.Varchar()).NotNull(),
	qb.Column(ProcessStatePMCommentColumnName, qb.Varchar()).NotNull(),
	qb.Column(ProcessStatePMChangedColumnName, qb.Timestamp()).NotNull(),
	qb.ForeignKey(ProcessStateProcessIDColumnName).References(ProcessTableName, BaseIDColumnName).OnDelete("CASCADE"),
)

var processStateType = reflect.TypeOf(ProcessState{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (ProcessState) StructType() reflect.Type {
	return processStateType
}

// ProcessStateModel provides direct access to helpers for ProcessState
// queries
type ProcessStateModel struct {
	mapper            *ProcessStateMapper
	ProcessID         yago.ScalarField
	Status            yago.MarshaledScalarField
	StatusChanged     yago.ScalarField
	StatusReason      yago.ScalarField
	NodeStates        yago.ScalarField
	NodeStatesChanged yago.ScalarField
	PMLevel           yago.MarshaledScalarField
	PMStatus          yago.MarshaledScalarField
	PMComment         yago.ScalarField
	PMChanged         yago.ScalarField
}

// NewProcessStateModel returns a new ProcessStateModel
func NewProcessStateModel(meta *yago.Metadata) ProcessStateModel {
	mapper := NewProcessStateMapper()
	meta.AddMapper(mapper)
	return ProcessStateModel{
		mapper:            mapper,
		ProcessID:         yago.NewScalarField(mapper.Table().C(ProcessStateProcessIDColumnName)),
		Status:            yago.NewMarshaledScalarField(mapper.Table().C(ProcessStateStatusColumnName)),
		StatusChanged:     yago.NewScalarField(mapper.Table().C(ProcessStateStatusChangedColumnName)),
		StatusReason:      yago.NewScalarField(mapper.Table().C(ProcessStateStatusReasonColumnName)),
		NodeStates:        yago.NewScalarField(mapper.Table().C(ProcessStateNodeStatesColumnName)),
		NodeStatesChanged: yago.NewScalarField(mapper.Table().C(ProcessStateNodeStatesChangedColumnName)),
		PMLevel:           yago.NewMarshaledScalarField(mapper.Table().C(ProcessStatePMLevelColumnName)),
		PMStatus:          yago.NewMarshaledScalarField(mapper.Table().C(ProcessStatePMStatusColumnName)),
		PMComment:         yago.NewScalarField(mapper.Table().C(ProcessStatePMCommentColumnName)),
		PMChanged:         yago.NewScalarField(mapper.Table().C(ProcessStatePMChangedColumnName)),
	}
}

// GetMapper returns the associated ProcessStateMapper instance
func (m ProcessStateModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewProcessStateMapper initialize a NewProcessStateMapper
func NewProcessStateMapper() *ProcessStateMapper {
	m := &ProcessStateMapper{}
	return m
}

// ProcessStateMapper is the ProcessState mapper
type ProcessStateMapper struct{}

// GetMapper returns itself
func (mapper *ProcessStateMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*ProcessStateMapper) Name() string {
	return "model/ProcessState"
}

// Table returns the mapper table
func (*ProcessStateMapper) Table() *qb.TableElem {
	return &processStateTable
}

// StructType returns the reflect.Type of the mapped structure
func (ProcessStateMapper) StructType() reflect.Type {
	return processStateType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper ProcessStateMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*ProcessState)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &ProcessState{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ProcessID != (uuid.UUID{}) {
		m[ProcessStateProcessIDColumnName] = s.ProcessID
	}
	if allValues || yago.StringListContains(fields, ProcessStateStatus) {
		if b, err := s.Status.MarshalText(); err == nil {
			m[ProcessStateStatusColumnName] = b
		} else {
			panic(err)
		}
	}
	if allValues || yago.StringListContains(fields, ProcessStateStatusChanged) {
		m[ProcessStateStatusChangedColumnName] = s.StatusChanged
	}
	if allValues || yago.StringListContains(fields, ProcessStateStatusReason) {
		m[ProcessStateStatusReasonColumnName] = s.StatusReason
	}
	if allValues || yago.StringListContains(fields, ProcessStateNodeStates) {
		m[ProcessStateNodeStatesColumnName] = s.NodeStates
	}
	if allValues || yago.StringListContains(fields, ProcessStateNodeStatesChanged) {
		m[ProcessStateNodeStatesChangedColumnName] = s.NodeStatesChanged
	}
	if allValues || yago.StringListContains(fields, ProcessStatePMLevel) {
		if b, err := s.PMLevel.MarshalText(); err == nil {
			m[ProcessStatePMLevelColumnName] = b
		} else {
			panic(err)
		}
	}
	if allValues || yago.StringListContains(fields, ProcessStatePMStatus) {
		if b, err := s.PMStatus.MarshalText(); err == nil {
			m[ProcessStatePMStatusColumnName] = b
		} else {
			panic(err)
		}
	}
	if allValues || yago.StringListContains(fields, ProcessStatePMComment) {
		m[ProcessStatePMCommentColumnName] = s.PMComment
	}
	if allValues || yago.StringListContains(fields, ProcessStatePMChanged) {
		m[ProcessStatePMChangedColumnName] = s.PMChanged
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper ProcessStateMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		processStateTable.C(ProcessStateProcessIDColumnName),
		processStateTable.C(ProcessStateStatusColumnName),
		processStateTable.C(ProcessStateStatusChangedColumnName),
		processStateTable.C(ProcessStateStatusReasonColumnName),
		processStateTable.C(ProcessStateNodeStatesColumnName),
		processStateTable.C(ProcessStateNodeStatesChangedColumnName),
		processStateTable.C(ProcessStatePMLevelColumnName),
		processStateTable.C(ProcessStatePMStatusColumnName),
		processStateTable.C(ProcessStatePMCommentColumnName),
		processStateTable.C(ProcessStatePMChangedColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper ProcessStateMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*ProcessState)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &ProcessState{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ProcessID,
	)
}

// Scan a struct
func (mapper ProcessStateMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*ProcessState)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &ProcessState{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	var StatusText []byte
	var PMLevelText []byte
	var PMStatusText []byte
	if err := rows.Scan(
		&s.ProcessID,
		&StatusText,
		&s.StatusChanged,
		&s.StatusReason,
		&s.NodeStates,
		&s.NodeStatesChanged,
		&PMLevelText,
		&PMStatusText,
		&s.PMComment,
		&s.PMChanged,
	); err != nil {
		return err
	}
	if err := s.Status.UnmarshalText(StatusText); err != nil {
		return err
	}
	if err := s.PMLevel.UnmarshalText(PMLevelText); err != nil {
		return err
	}
	if err := s.PMStatus.UnmarshalText(PMStatusText); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (ProcessStateMapper) AutoIncrementPKey() bool {
	return false
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (ProcessStateMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	panic("ProcessState has no auto increment column in its pkey")
}

// PKey returns the instance primary key values
func (mapper ProcessStateMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*ProcessState)
	values = append(values, str.ProcessID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper ProcessStateMapper) PKeyClause(values []interface{}) qb.Clause {
	return processStateTable.C(ProcessStateProcessIDColumnName).Eq(values[0])
}
