package api

const (
	// CorePrefix is the prefix for core related apis
	CorePrefix = XbusAPIPrefix + "core."

	// CoreEventsPrefix is the prefix for core events related apis
	CoreEventsPrefix = XbusAPIPrefix + "events."

	// CoreActorEventsSubject is the subject for actor events
	CoreActorEventsSubject = CoreEventsPrefix + "actor"

	// CoreProcessEventsSubject is the subject for process events
	CoreProcessEventsSubject = CoreEventsPrefix + "process"
)

// CoreEvent is the message sent on CoreEventsPrefix subjects
type CoreEvent struct {
	Name    string  `json:"name"`
	Actor   Actor   `json:"actor,omitempty"`
	Process Process `json:"process,omitempty"`
}
