package api

import (
	"github.com/m4rw3r/uuid"
)

const (
	// ActorReadyPrefix is the prefix of ActorReady subjects
	ActorReadyPrefix = XbusAPIPrefix + "actorready."
)

// ActorReadySubject returns the subject on which an actor should signal
// that it is ready (to emit or receive)
func ActorReadySubject(actorID uuid.UUID) string {
	if actorID.IsZero() {
		return ActorReadyPrefix + "*"
	}
	return ActorReadyPrefix + actorID.String()
}

// ActorReadyMsg is the msg to send to ActorReady subjects
type ActorReadyMsg struct{}
